#include <iostream>
using namespace std;
#include <stdlib.h>
#include "ListaR.h"

/********************************************************/
/*Constructor de la la clase ListaH                     */
/********************************************************/
ListaR::ListaR (void)
{
    ini = NULL;
    pto = ini;
}

/********************************************************/
/*Destructor de la la clase ListaH                      */
/********************************************************/
ListaR::~ListaR (void)
{
  Puntero1 p_aux;

  p_aux = ini;

  while (p_aux != NULL)
  {
     ini = p_aux->Sig;
     delete p_aux;
     p_aux = ini;
  }
}


/********************************************************/
/*Insertar delante del punto de interes                 */
/********************************************************/
bool ListaR::Insertar (ValorR x)
{
   Puntero1 p_aux;
   bool error;

   error = false;
   p_aux = new (Nodo1);

   if (ini == NULL) //Si la lista estaba vacia
   {
    ini= p_aux;
    fin = p_aux;
    p_aux->Info = x;
    p_aux->Sig = NULL;
   }
    else
    {
        if (pto != NULL)  //Si es un punto intermedio
        {

         *p_aux = *pto;
         pto->Sig = p_aux;
         pto->Info = x;
         pto = p_aux;
         }
         else  //Si se inserta delante del punto ms a la derecha
         {
             fin->Sig = p_aux;
             fin = p_aux;
             p_aux->Info = x;
             fin->Sig = pto;
         }
    }
   return error;
}

/********************************************************/
/*Eliminar el nodo al que apunta el punto de inters    */
/********************************************************/
bool ListaR::Eliminar (void)
{
   Puntero1 p_aux, ant;
   bool error = false;

   if (pto == NULL)    //no se puede borrar
      error = true;
   else
   {
       error = false;   //si se puede borrar
       if (pto == ini)  //pto de interes en el primer elemento
       {
          ini = pto->Sig;
          delete pto;
          pto = ini;
       }
       else          //pto. de interes en cualquier otro elemento
       {
           ant = NULL;
           p_aux = ini;
           while (p_aux->Sig !=pto)  //recorro hasta que encuentro el pto.
           {
               ant = p_aux;
               p_aux = p_aux->Sig;
           }
           if (pto == fin)
              fin = p_aux;
           p_aux->Sig = pto->Sig;
           delete pto;
           pto = p_aux;
       }
   }
   return error;
}

/********************************************************/
/*Consultar la informacin del nodo al que apunta el    */
/* punto de inters                                     */
/********************************************************/
bool ListaR::Consulta(ValorR & x)
{
   bool error = false;

   if (pto == NULL)
      error = true;
   else
   {
      x = pto->Info;
      error = false;
   }
   return error;
}

/********************************************************/
/* Devuelve true si la lista est vacia                 */
/********************************************************/
bool ListaR::ListaVacia (void)
{
   return  ini == NULL;
}

/********************************************************/
/*Mover punto de inters al inicio de la lista          */
/********************************************************/
void ListaR::IrAInicio(void)
{
   pto = ini;
}

/********************************************************/
/*Mover punto de inters hacia delante                  */
/********************************************************/
bool ListaR::Avanzar(void)
{
   bool error;

   if (pto == NULL)
      error = true;
   else
   {
     pto = pto->Sig;
     error = false;

   }
   return error;
}

/********************************************************/
/*  Comprobar si el punto de inters est al final de   */
/*  la lista                                            */
/********************************************************/
bool ListaR::FinalLista (void)
{
  return pto == NULL;
}

/********************************************************/
/*Constructor de copia de la la clase Lista             */
/*creo que no se va a seguir este formato               */
/********************************************************/
ListaR::ListaR (const ListaR & list)
{
    Copiar (ini, Puntero1(list.ini));
    PonerPtoInteres ((ListaR &)(list));
    PonerFin ();
}

//Funciones privadas utilizadas  por el constructor de copia

/********************************************************/
/*permite crear una lista identica a otra existente     */
/*anteriormente                                         */
/********************************************************/
void ListaR::Copiar (Puntero1 & des, Puntero1 ori)
{
   if (ori != NULL)
   {
      des = new Nodo1;
      des->Info = ori->Info;
      Copiar(des->Sig, ori->Sig);
   }
   else
       des = NULL;

}

/********************************************************/
/*pone punto de interes a una nueva lista               */
/********************************************************/
void ListaR::PonerPtoInteres(ListaR &list)
{
    Puntero1 p_aux1, p_aux2;

    p_aux1 = ini;
    p_aux2 = list.ini;

    while (p_aux2 != list.pto)
    {
       p_aux1 = p_aux1->Sig;
       p_aux2 = p_aux2->Sig;
    }
    pto = p_aux1;
}

/********************************************************/
/*pone el fin a una lista                               */
/********************************************************/
void ListaR::PonerFin (void)
{
   Puntero1 p_aux;

   if(ini != NULL)
   {
       p_aux = ini;
       while (p_aux->Sig != NULL)
          p_aux = p_aux->Sig;

       fin = p_aux;
   }
}

