/***************************************************************************/
/*programa de paco soriano de gestion del hotel de los lios                */
/*curso 2003-4                                                             */
/*Algunas funciones se pueden mejorar. Estaban hechas inicialmente para    */
/*hacer otro tipo de comprobaciones y por vagueria no se han rehecho       */
/*                                                                         */
/*Los datos que coge y deja este programa estaran en c:\tmp                */
/***************************************************************************/

#include <iostream>
#include <fstream>
#include <string>
using namespace std;
#include <stdlib.h>

#include "ListaH.h"  //lista de habitaciones
#include "ListaR.h"  //lista de reservas

int menu (void);
void ocupacion (ListaH & hotel , ListaR reservas, fecha hoy);
void introvalores(Habitacion & h);
void mostrar(Habitacion h);
void mostrarR(int n, ListaR reservas);
void modificaestatico(Habitacion & h);
void mostrarfecha (fecha x);
bool analiza (string dia, fecha & di);
bool CadenaAEntero (string num, int & x);
void EnteroACadena (int x, string & num);
bool ValidarFecha(fecha f);
void guardah (ListaH hotel);
void guardar (ListaR reservas);
void lecturah (ListaH & hotel);
void lecturar (ListaR & reservas,int & n);
bool mayor (fecha x, fecha y);
bool igual (fecha x, fecha y);
bool tienereservas (Habitacion h, ListaR reservas);
void quehabitacionquiere(Habitacion & h, Reserva & r, fecha hoy);
void buscardisponibilidad(Habitacion h, Reserva r,ListaH & hotel, ListaR & reservas, int & n);
bool solapa (Reserva r1, Reserva r2);
void InsertarOrden (Reserva r, ListaR & reservas);
void incrementahoy(fecha & hoy);
void facturas(fecha hoy,ListaR & reservas,ListaH & hotel);
int numerodias (Reserva r);
bool posiblecambio (fecha nuevasalida, Reserva & r, ListaR reservas, Reserva & rnuevo);

int main()
{
   ListaH hotel; //las habitaciones
   ListaR reservas; //las reservas
   Habitacion h; //habitacion
   Reserva r, rnuevo;  //reserva
   int op, numh, numr, n;
   fecha hoy, nuevasalida;
   string di;
   bool correcto, encontrado;

   do //introduzco una fecha correcta
   {
      cout << "Fecha de hoy con el siguiente formato: dd/mm/aa: ";
      cin >> di;
      correcto = analiza (di, hoy);
   }while(!correcto);
   
   numh = 0;
   numr = 0;
   
   lecturah (hotel);    //leo habitaciones
   lecturar (reservas, numr); //leo reservas
   ocupacion (hotel, reservas, hoy); //asigno el campo ocupada 

   do{
      system("cls");
      mostrarfecha(hoy);   //fecha de hoy
      op = menu();         //menu de opciones

      switch (op)
      {
        case 1:
            //recupero el ultimo numero de habitacion  
            hotel.IrAInicio();
            while (!hotel.FinalLista())
            {
               hotel.Consulta(h);
               numh = h.NumHabita; 
               hotel.Avanzar();
            }   
            numh ++;  //nuevo numero de habitacion
            h.NumHabita = numh;
            introvalores(h);  //valores de la nueva habitacion
            hotel.Insertar(h);
            break;
         case 2:
            //recorro la lista de habitaciones y la muestro
            hotel.IrAInicio();
            while(!hotel.FinalLista())
            {
               hotel.Consulta(h);
               mostrar(h);
               system("pause");
               hotel.Avanzar();
            }
            break;
         case 3:
            cout << "Dame numero de habitacion para modificacion: ";
            cin >> n;
            encontrado = false;
            //busco la habitacion a modificar
            hotel.IrAInicio();
            while(!hotel.FinalLista() && !encontrado)
            {
               hotel.Consulta(h);
               if(h.NumHabita == n) //la encuentro
               {
                  encontrado = true;
                  //comprueba si no tiene reservas asociadas
                  if (!tienereservas(h, reservas))
                  {
                     modificaestatico(h);
                     hotel.Insertar(h);
                     hotel.Eliminar();
                  }
                  else
                  {
                     cout << "La habitacion " << n << " tiene reservas y";
                     cout << " no se pueden hacer modificaciones." << endl;
                  }
               }
               else
                  hotel.Avanzar();
            }
            if(!encontrado)
               cout << "No existe la habitacion numero: " << n << endl;
            system("pause");
            break;    
         case 4:
            cout << "Dame numero de habitacion para quitar: ";
            cin >> n;
            encontrado = false;
            //recorro la lista de habitaciones hasta que encuentro la que busco
            hotel.IrAInicio();
            while(!hotel.FinalLista() && !encontrado)
            {
               hotel.Consulta(h);
               if(h.NumHabita == n)
               {
                  encontrado = true;
                  //compruebo si tiene reservas asociadas
                  if (!tienereservas(h, reservas))
                  {
                      hotel.Eliminar();
                      cout << "Habitacion " << n << " quitada del hotel" << endl;
                  }
                  else
                  {
                      cout << "La habitacion " << n << " tiene reservas y";
                      cout << " no se pueden quitar." << endl;
                  }
               }
               else
                  hotel.Avanzar();
            }
            if(!encontrado)
               cout << "No existe la habitacion numero: " << n << endl;
            system("pause");
            break;
         case 5:
            //tipo de habitacion que quiere y fecha de entrada y salida
            quehabitacionquiere(h, r, hoy);
            //si existe la habitacion la reserva
            buscardisponibilidad(h, r, hotel, reservas, numr);
            break;
         case 6:
            //recorro la lista de habitaciones
            hotel.IrAInicio();
            while(!hotel.FinalLista())
            {
               hotel.Consulta(h);
               mostrar(h);   //muestro datos de habitacion
               mostrarR(h.NumHabita, reservas); //muestro datos reservas de esa habitacion
               hotel.Avanzar();
            }
            break;
         case 7:
            cout << "Dame numero de reserva para quitar: ";
            cin >> n;
            encontrado = false;
            //busco numero de reserva
            reservas.IrAInicio();
            while(!reservas.FinalLista() && !encontrado)
            {
               reservas.Consulta(r);
               if(r.NumReserva == n)
               {
                  //he encontrado la reserva
                  encontrado = true;
                  //solo si no esta ocupada ya la habitacion con esa reserva
                  if (mayor(r.entrada,hoy))
                  {
                     reservas.Eliminar();
                     cout << "Reserva " << n << " quitada" << endl;
                  }
                  else
                  {
                     cout << "Esta reserva ya esta ocupando la habitacion" << endl;   
                     cout << "Debera hacerse una modificacion de reserva" << endl;
                  }   
               }
               else
                  reservas.Avanzar();
            }    
            if(!encontrado)
               cout << "No existe la reserva numero: " << n << endl;
            system("pause");
            break;
         case 8:
            cout << "Dame numero de reserva que quieres modificar: ";
            cin >> n;
            encontrado = false;
            //busco la reserva a modificar
            reservas.IrAInicio();
            while(!reservas.FinalLista() && !encontrado)
            {
               reservas.Consulta(r);
               if(r.NumReserva == n)
               {
                   encontrado = true;
                   //la habitacion debe estar ocupada con esa reserva
                   if (!mayor(hoy,r.entrada))
                   {
                     cout << "No se esta usando la habitacion" << endl;
                     cout << "No se puede modificar la reserva" << endl;
                     cout << "Debe anularse y abrise otra reserva distinta" << endl;
                   }
                   else
                   {
                      do //nueva fecha de salida correcta
                      {
                        correcto = true;
                        cout << "Nuevo dia de salida con el siguiente formato: dd/mm/aa: ";
                        cin >> di;
                        correcto = analiza (di,nuevasalida);
                        if(!mayor(nuevasalida, r.entrada))
                           correcto = false;
                        if(mayor(hoy,nuevasalida))
                           correcto = false;   
                      }while(!correcto);
                      //si se reduce estancia o no interfiere con la siguiente reserva de
                      //esa habitacion
                      if(posiblecambio(nuevasalida,r,reservas,rnuevo))
                      {
                        
                        reservas.Insertar(r);
                        reservas.Eliminar();
                      }  
                      else  
                      {  //se reserva hasta la fecha maxima posible y se 
                         //abre nueva reserva
                         reservas.Insertar(r);
                         reservas.Eliminar();
                         cout << "Se ha extendido la reserva " << r.NumReserva << endl;
                         cout << "Hasta el dia maximo y se ha abierto una nueva reserva" << endl;
                         hotel.IrAInicio(); //saco datos estaticos de la habitacion
                         hotel.Consulta(h);
                         while(h.NumHabita != r.NumHabitaR)
                         {
                           hotel.Avanzar();
                           hotel.Consulta(h);
                         }
                         //hago nueva reserva si posible
                         buscardisponibilidad(h, rnuevo, hotel, reservas, numr);
                      }   
                   }
               }    
               else
                  reservas.Avanzar();
            }
            if(!encontrado)
               cout << "No existe la reserva numero: " << n << endl;
            system("pause");
            break;
         case 9:
            incrementahoy(hoy);  //es un nuevo dia
            facturas(hoy,reservas,hotel); //emito facturas de las reservas que terminan
            ocupacion (hotel, reservas, hoy); //cambio estado de ocupacion de habitaciones
            break;
         case 0:
            cout << "Adios" << endl;
            break;
         default:
            cout << "opcion mal elegida." << endl;
      };
   }while (op != 0);

   guardah (hotel);   //guardo en fichero la lista de habitaciones
   guardar (reservas);  //guardo en fichero la lista de reservas

   system("pause");
   return 0;
}

/******************************************************************************/
/*menu      muestra en pantalla el menu de opciones                           */
/*devuelve la opcion elegida                                                  */
/******************************************************************************/
int menu(void)
{
   int opcion;
   cout << "Gestion de este Lio de Hotel" << endl;
   cout << "1.- Anyadir habitacion" << endl;
   cout << "2.- Mostrar habitaciones" << endl;
   cout << "3.- Modificar dato de habitacion" << endl;
   cout << "4.- Quitar habitacion" << endl;
   cout << "5.- Hacer reserva" << endl;
   cout << "6.- Mostrar habitaciones y reservas" << endl;
   cout << "7.- Quitar reserva" << endl;
   cout << "8.- Modificar reserva" << endl;
   cout << "9.- Ha pasado un dia" << endl;
   cout << "0.- Salir" << endl;

   cout << "Elige opcion: ";
   cin >> opcion;

   return opcion;
}

/******************************************************************************/
/*introvalores     permite introducir los datos de una nueva habitacion       */
/*parametros E/S                                                              */
/*h          S     los datos de la nueva habitacion introducida               */
/******************************************************************************/
void introvalores(Habitacion & h)
{
   char f;

   system("cls");
   cout << "Introducir datos de habitacion " << h.NumHabita << endl;
   cout << "Fumador?(s/n): ";
   cin >> f;
   if (f == 's')
      h.fumador = true;
   else
      h.fumador = false;
   cout << "Tipo: 1.- Sencilla, 2.- Doble, 3.-Suite: ";
   cin >> h.tipo;
   cout << "Precio en euros: ";
   cin >> h.precio;

   h.ocupada = false; //no ocupada por defecto
}

/******************************************************************************/
/*mostrar     muestra por pantalla los datos de una habitacion                */
/*parametros E/S                                                              */
/*h          E     la habitacion a mostrar                                    */
/******************************************************************************/
void mostrar(Habitacion h)
{
   system("cls");
   cout << "Habitacion: \t" << h.NumHabita << endl;
   if (h.fumador)
       cout << "Fumador";
   else
       cout << "No Fumador";
   cout << endl;

   switch(h.tipo)
   {
      case 1:
         cout << "Sencilla";
         break;
      case 2:
         cout << "Doble";
         break;
      case 3:
         cout << "Suite";
         break;
   };
   cout << endl;

   cout << "Precio: \t" << h.precio << endl;
   if (h.ocupada)
       cout << "Habitacion Ocupada";
   else
       cout << "Habitacion Libre";

   cout << endl << endl;
}

/******************************************************************************/
/*mostrarR     muestra por pantalla las reservas de una habitacion            */
/*parametros E/S                                                              */
/*n          E     numero de habitacion de la que se quiere mostrar reservas  */
/*reservas   E     lista de reservas                                          */
/******************************************************************************/
void mostrarR(int n, ListaR reservas)
{
   Reserva r;

   reservas.IrAInicio();
   while (!reservas.FinalLista())
   {
      reservas.Consulta(r);
      if(r.NumHabitaR == n)
      {
         cout << "Reserva numero: " << r.NumReserva << endl;
         cout << "A nombre de: " << r.nombre << endl;
         cout << "Fecha de entrada: ";
         mostrarfecha(r.entrada);
         cout << "Fecha de salida: ";
         mostrarfecha(r.salida);
         cout << endl;
      }
      reservas.Avanzar();
   }
   system("pause");
}

/******************************************************************************/
/*modificaestatico     permite modificar los datos de una habitacion          */
/*parametros E/S                                                              */
/*h          E/S     la habitacion                                            */
/******************************************************************************/
void modificaestatico(Habitacion & h)
{
   int m;

   mostrar(h);

   cout << "Solo puedes modificar datos estaticos de la habitacion" << endl;
   cout << "Dime que quieres cambiar:" << endl;
   cout << "1.- Fumador" << endl;
   cout << "2.- Tipo" << endl;
   cout << "3.- Precio" << endl;
   cin >> m;
   switch (m)
   {
      case 1:
        if(h.fumador)
           h.fumador = false;
        else
           h.fumador = true;
        break;
      case 2:
        cout << "Actualmente figura como " << h.tipo << endl;
        cout << "Elige a que tipo quiere cambiarse" << endl;
        cout << "Tipo: 1.- Sencilla, 2.- Doble, 3.-Suite: ";
        cin >> h.tipo;
        break;
      case 3:
        cout << "Precio actual: " << h.precio << endl;
        cout << "Nuevo precio: ";
        cin >> h.precio;
        break;
   };
}

/******************************************************************************/
/*mostrarfecha     muestra una fecha por pantalla en formato dd/mm/aaaa       */
/*parametros E/S                                                              */
/*x          E     la fecha a mostrar                                         */
/******************************************************************************/
void mostrarfecha (fecha x)
{
   if (x.dia < 10)
      cout << "0";
   cout << x.dia;
   cout << "/";
   if (x.mes < 10)
      cout << "0";
   cout << x.mes;
   cout << "/";
   if (x.anyo < 10)
      cout << "200";
   else
      cout << "20";
   cout << x.anyo << endl;
}

/******************************************************************************/
/*ocupacion     recorre la lista de habitaciones y la lista de reservas y pone*/
/*    el valor del campo "ocupada" de una habitacion segun sea la fecha actual*/
/*parametros E/S                                                              */
/*hotel      E/S   lista de habitaciones del hotel                            */
/*reservas   E     lista de reservas                                          */
/*hoy        E     fecha del dia actual                                       */
/******************************************************************************/
void ocupacion (ListaH & hotel , ListaR reservas, fecha hoy)
{
   Reserva r;
   Habitacion h, h1;
   bool encontrado;
   
   reservas.IrAInicio();
   while(!reservas.FinalLista())
   {
      reservas.Consulta(r);
      if (mayor(hoy,r.entrada) || igual (hoy,r.entrada))
      {
         encontrado = false;
         hotel.IrAInicio();
         while(!encontrado)
         {
            hotel.Consulta(h); 
            if(h.NumHabita == r.NumHabitaR)
            {
               hotel.Eliminar();
               h.ocupada = true;
               encontrado = true;
               hotel.IrAInicio();
               hotel.Consulta(h1);
               while((h1.NumHabita < h.NumHabita) && !hotel.FinalLista())
               {    
                  hotel.Avanzar();
                  hotel.Consulta(h1);
               }   
               hotel.Insertar(h);
            }
            else
               hotel.Avanzar();
         }   
      }
      reservas.Avanzar();   
   }
}

/******************************************************************************/
/*quehabitacionquiere    un usuario introduce que tipo de habitacion quiere   */
/*                       y las fechas entre las que se quiere usar el hotel   */
/*parametros E/S                                                              */
/*h          S     tipo de habitacion que quiero reservar                     */
/*r          S     fechas de entrada y salida y nombre del inquilino          */
/*hoy        E     fecha del dia actual                                       */
/******************************************************************************/
void quehabitacionquiere(Habitacion & h, Reserva & r, fecha hoy)
{
   string x;
   char f;
   bool correcto = false;
   system("cls");
   cout << "Bienvenido a la Central de Reservas" << endl;
   do
   {
      cout << "Dia de entrada con el siguiente formato: dd/mm/aa: ";
      cin >> x;
      correcto = analiza (x,r.entrada);
      if (mayor(hoy, r.entrada))
         correcto = false;
   }while(!correcto);
   correcto = false;
   do
   {
      cout << "Dia de salida con el siguiente formato: dd/mm/aa: ";
      cin >> x;
      correcto = analiza (x,r.salida);
      if(!mayor(r.salida, r.entrada))
         correcto = false;
   }while(!correcto);

   cout << "Nombre y Apellidos: ";
   cin.ignore();
   getline (cin,r.nombre);
   cout << endl;
   
   cout << "Fumador?(s/n): ";
   cin >> f;
   if (f == 's')
      h.fumador = true;
   else
      h.fumador = false;
   cout << "Tipo: 1.- Sencilla, 2.- Doble, 3.-Suite: ";
   cin >> h.tipo;

   system("pause");
}

/******************************************************************************/
/*analiza          analiza la fecha introducida y si es correcta la pasa      */
/*                 de formato string a formato struct fecha                   */
/*parametros E/S                                                              */
/*di         E     string que se va a analizar                                */
/*f          S     fecha en la que se tranformara el string si es correcto    */
/*devuelve si el correcto que el string que se analiza es valido como fecha   */
/******************************************************************************/
bool analiza (string di, fecha & f)
{
   string x;
   bool error, bien = false;
   if (di.length() == 8)
   {
      if((di.substr(2,1)== "/") && (di.substr(5,1)== "/"))
      {
         x = di.substr(0,2);
         error = CadenaAEntero(x, f.dia);
         if(!error)
         {
            x = di.substr(3,2);
            error = CadenaAEntero(x, f.mes);
            if(!error)
            {
               x = di.substr(6,2);
               error = CadenaAEntero(x, f.anyo);
               if(!error)
               {
                  if (ValidarFecha(f) == false)  //no hay error
                     bien = true;
               }
            }
         }
      }
   }
   return bien;
}

/******************************************************************************/
/*CadenaAEntero    tranforma un string en un entero                           */
/*parametros E/S                                                              */
/*num        E     cadena que se va a tratar de convertir en entero           */
/*x          S     entero en que se ha transformado la cadena                 */
/*devuelve si ha sido posible la conversion de la cadena en entero            */
/******************************************************************************/
bool CadenaAEntero (string num, int & x)
{
    bool error = false;
    int i;

    i = 0;
    x = 0;
    while ( (error == false) && (i < int (num.length () ) ) )
    {
       if ( (int (num[i]) < int('0') ) || (int (num[i]) > int ('9') ) )
          error = true;
       else
          x = x * 10 + int (num[i] - '0');
       i++;
    }

    return error;
}

/******************************************************************************/
/*ValidarFecha    comprueba si una fecha es correcta.                         */
/*                solo se admiten 12 meses de 30 dias                         */
/*parametros E/S                                                              */
/*f          E     fecha a comprobar                                          */
/*devuelve si se trata de una fecha valida                                    */
/******************************************************************************/
bool ValidarFecha(fecha f)
{
   bool error = false;

   if (f.anyo < 0 || f.anyo > 99)
      error = true;
   else
      if (f.mes < 1 ||f.mes > 12)
         error = true;
      else
         if (f.dia < 1 || f.dia > 30)
             error = true;

  return error;
}

/******************************************************************************/
/*buscardisponibilidad   busca si existe la habitacion deseada y la reserva   */
/*parametros E/S                                                              */
/*hquiere    E     tipo de habitacion que quiero reservar                     */
/*rquiere    E     fechas de entrada y salida y nombre del inquilino          */
/*hotel      E/S   lista de habitaciones disponibles y su ocupacion           */
/*reservas   E/S   lista de reservas existentes en el hotel                   */
/*numr       E/S   numero de la ultima reserva                                */
/******************************************************************************/
void buscardisponibilidad(Habitacion hquiere, Reserva rquiere,ListaH & hotel, ListaR & reservas, int & numr)
{
   bool encontrado = false;
   bool posible;
   Reserva r;
   Habitacion h;
   //recorro todas las habitaciones
   hotel.IrAInicio();
   while(!hotel.FinalLista() && !encontrado)
   {
       hotel.Consulta(h);
       //en cada habitacion comprueba si es del tipo que quiere
       if((hquiere.fumador == h.fumador) && (hquiere.tipo == h.tipo))
       {
          posible = true;
          reservas.IrAInicio();
          //comprueba todas las reservas
          while(!reservas.FinalLista() && !encontrado && posible)
          {
            reservas.Consulta(r);
         
            while((r.NumHabitaR != h.NumHabita)&&!reservas.FinalLista())
            {
               reservas.Avanzar();
               reservas.Consulta(r);
            }   
            //si estoy al final de la lista puedo hacer la reserva en esa habitacion
            if(reservas.FinalLista())
               encontrado = true;
            else
            {  
               //si una sola de las reservas de esa habitacion se solapa con lo que quiero
               //no puedo hacer reserva en esa habitacion 
               while((r.NumHabitaR == h.NumHabita) && !reservas.FinalLista() && posible)
               {
                  if (solapa(r,rquiere))
                     posible = false;  
                  else
                  {
                     reservas.Avanzar();   
                     reservas.Consulta(r);
                  }   
               }
               if(posible || reservas.FinalLista())
                  encontrado = true;
            }      
          }
          if (encontrado) //si puedo hacer reserva en esa habitacion
          {
             cout << "Reserva asignada con los siguientes datos:" << endl;
             cout << "Habitacion \t" << h.NumHabita << endl;
             cout << "Precio \t" << h.precio << endl;
      
             numr ++;
             cout << "Se le ha dado la reserva numero: " << numr << endl;
             rquiere.NumReserva = numr;
             rquiere.NumHabitaR = h.NumHabita;
             //inserto la reserva nueva en el orden correcto
             //primero por orden de habitacion y luego por orden de fecha
             InsertarOrden (rquiere, reservas);
          
             h.ocupada = false;
             hotel.Insertar(h);
             hotel.Eliminar();
          }
          else
            hotel.Avanzar();
       }
       else
         hotel.Avanzar();     
   }
   if(!encontrado)
      cout << "No existe la habitacion que usted desea" << endl;

   system("pause");
}

/******************************************************************************/
/*guardah          guarda en un fichero la lista de habitaciones              */
/*                 y elimina esta lista de habitaciones                       */
/*parametros E/S                                                              */
/*hotel      E     lista de habitaciones a guardar                            */
/******************************************************************************/
void guardah (ListaH hotel)
{
   ofstream fich;
   Habitacion h;
   fich.open("c:\\tmp\\habita.txt");
   if(!fich)
      cout << "Error de apertura de fichero";
   else
   {
      hotel.IrAInicio();
      while(!hotel.ListaVacia())
      {
         hotel.Consulta(h);
         fich << h.NumHabita << " ";
         if (h.fumador)
            fich << "s";
         else
            fich << "n";

         fich << " " << h.tipo << " ";
         fich << h.precio << endl;
         hotel.Eliminar();
         //hotel.Avanzar();
      }
   }
   fich.close();
}

/******************************************************************************/
/*guardar          guarda en un fichero la lista de reservas                  */
/*                 y elimina esta lista de reservas                           */
/*parametros E/S                                                              */
/*reservas   E     lista de reservas a guardar                                */
/******************************************************************************/
void guardar (ListaR reservas)
{
   ofstream fich;
   Reserva r;
   fich.open("c:\\tmp\\reserva.txt");
   if(!fich)
      cout << "Error de apertura de fichero";
   else
   {
      reservas.IrAInicio();
      while(!reservas.ListaVacia())
      {
         reservas.Consulta(r);
         fich << r.NumReserva << " " << r.NumHabitaR << " ";

         if (r.entrada.dia < 10)
            fich << "0";
         fich << r.entrada.dia << "/";
         if (r.entrada.mes < 10)
            fich << "0";
         fich << r.entrada.mes << "/";
         if (r.entrada.anyo < 10)
            fich << "0";
         fich << r.entrada.anyo << " ";

         if (r.salida.dia < 10)
            fich << "0";
         fich << r.salida.dia << "/";
         if (r.salida.mes < 10)
            fich << "0";
         fich << r.salida.mes << "/";
         if (r.salida.anyo < 10)
            fich << "0";
         fich << r.salida.anyo << endl;

         fich << r.nombre << endl;

         reservas.Eliminar();
      }
   }
   fich.close();
}

/******************************************************************************/
/*lecturah          leo las habitaciones alamacenadas en un fichero y lo pongo*/
/*                  en una lista de habitaciones                              */
/*parametros E/S                                                              */
/*hotel      S     lista de habitaciones leida                                */
/******************************************************************************/
void lecturah (ListaH & hotel)
{
   ifstream fich;
   Habitacion h;
   char c;
   fich.open("c:\\tmp\\habita.txt");
   if(!fich)
      cout << "Error de apertura de fichero";
   else
   {
      hotel.IrAInicio();
      while (fich >> h.NumHabita)
      {
         fich >> c;
         if (c == 's')
            h.fumador = true;
         else
            h.fumador = false;

         fich >> h.tipo;
         fich >> h.precio;

         h.ocupada = false;   //por defecto

         hotel.Insertar(h);
      }
   }
   fich.close();
}

/******************************************************************************/
/*lecturar         leo la lista de reservas de un fichero de entrada          */
/*parametros E/S                                                              */
/*reserva    S     lista de reservas que se lee y se genera                   */
/*n          S     el mayor nmero de reserva                                 */
/******************************************************************************/
void lecturar (ListaR & reserva,int & n)
{
   ifstream fich;
   Reserva r;
   string s, s1;
   bool correcto;
   fich.open("c:\\tmp\\reserva.txt");
   if(!fich)
      cout << "Error de apertura de fichero";
   else
   {
      n = 0;
      reserva.IrAInicio();
      while (fich >> r.NumReserva)
      {
         
         if (r.NumReserva > n)
            n = r.NumReserva;  //guardo el mayor
         
         fich >> r.NumHabitaR;

         getline(fich,s); 
         s1 = s.substr(1,8);
         
         //si se suponer que las fechas son correctas en el fichero
         //esto no hace falta
         
         correcto = analiza (s1, r.entrada);
         if (!correcto)
            cout << "Error de lectura de fecha de entrada" << endl;
         cout << " ";
         s1 = s.substr(10,8);
         correcto = analiza (s1, r.salida);
         if (!correcto)
            cout << "Error de lectura de fecha de salida" << endl;

         getline(fich,r.nombre);

         reserva.Insertar(r);
      }
   }
   fich.close();
}

/******************************************************************************/
/*mayor          comprueba si una fecha es mayor que otra                     */
/*parametros E/S                                                              */
/*x          E     fecha primera                                              */
/*y          E     fecha segunda                                              */
/******************************************************************************/
bool mayor (fecha x, fecha y)
{
   bool res = false;
   if (x.anyo > y.anyo)
      res = true;
   else
      if ((x.anyo == y.anyo) && (x.mes > y.mes))
         res = true;
         else
            if ((x.anyo == y.anyo) && (x.mes == y.mes) && (x.dia > y.dia))
               res = true;

   return res;
}

/******************************************************************************/
/*igual          comprueba si una fecha es igual que otra                     */
/*parametros E/S                                                              */
/*x          E     fecha primera                                              */
/*y          E     fecha segunda                                              */
/******************************************************************************/
bool igual (fecha x, fecha y)
{
   bool res = false;
   if ((x.anyo == y.anyo)&&(x.mes == y.mes)&&(x.dia == y.dia))
      res = true;
      
   return res;
}

/******************************************************************************/
/*tienereservas      comprueba si una habitacion tiene alguna reserva hecha   */
/*parametros E/S                                                              */
/*h          E     habitacion que se quiere comprobar si tiene reservas       */
/*reservas   E     lista de reservas existentes                               */
/*devuelve si existen reservas                                                */
/******************************************************************************/
bool tienereservas (Habitacion h, ListaR reservas)
{
   bool encontrado = false;
   Reserva r;

   reservas.IrAInicio();
   while(!reservas.FinalLista() && !encontrado)
   {
      reservas.Consulta(r);
      if(h.NumHabita == r.NumHabitaR)
         encontrado = true;
         
      else
         reservas.Avanzar();
   }
   return encontrado;
}

/******************************************************************************/
/*solapa      comprueba si las fechas de 2 reservas se solapan                */
/*parametros E/S                                                              */
/*r1         E     reserva primera                                            */
/*r2         E     reserva segunda                                            */
/*devuelve si se solapan                                                      */
/******************************************************************************/
bool solapa (Reserva r1, Reserva r2)
{
   bool res = true;
   
   if (mayor (r2.entrada,r1.salida) && mayor (r2.salida,r1.salida)) 
      res = false;
      
   if (mayor (r1.entrada,r2.salida) && mayor (r1.salida,r2.salida))
      res = false;
      
   return res;   
}

/******************************************************************************/
/*InsertarOrden     inserta una reserva en una lista de reservas con un orden */
/*            determinado: primero por habitacion y luego por fecha de entrada*/
/*parametros E/S                                                              */
/*r          E     reserva a insertar                                         */
/*reservas   E/S   lista de reservas existentes y como quedara                */
/******************************************************************************/
void InsertarOrden (Reserva r, ListaR & reservas)
{
   Reserva r1;
   bool insertado = false;
   reservas.IrAInicio();
   while(!reservas.FinalLista() && !insertado)
   {
      reservas.Consulta(r1);
      if((r1.NumHabitaR < r.NumHabitaR)&& !reservas.FinalLista())
         reservas.Avanzar();
      else
      {   
         if ((mayor(r1.entrada,r.salida))||(r1.NumHabitaR > r.NumHabitaR))
         {
            reservas.Insertar(r);
            insertado = true;
         }   
         else
            reservas.Avanzar();   
      }  
   }  
   if (!insertado)
      reservas.Insertar(r); 
}

/******************************************************************************/
/*incrementarhoy     avanza en uno el dia actual                              */
/*parametros E/S                                                              */
/*hoy        E/S   dia actual y como queda                                    */
/******************************************************************************/
void incrementahoy(fecha & hoy)
{
   if (hoy.dia < 30)
      hoy.dia ++;
   else
   {
      hoy.dia = 1;
      if (hoy.mes < 12)
         hoy.mes ++;
      else
      {
         hoy.mes = 1;
         hoy.anyo ++;   
      }
   }      
}

/******************************************************************************/
/*EnteroACadena     transforma un entero en una cadena                        */
/*parametros E/S                                                              */
/*x          E     entero a convertir en cadena                               */
/*num        S     string resultantes de la conversion                        */
/******************************************************************************/
void EnteroACadena (int x, string & num)
{
    num = "";
    while (x > 0)
    {
       num = char( (x % 10) + int ('0') )+num;
       x /= 10;
    }
}

/******************************************************************************/
/*facturas      genera facturas (ficheros) teniendo en cuenta las reservas    */
/*              que caducan hoy                                               */
/*parametros E/S                                                              */
/*hoy        E     dia actual                                                 */
/*reservas   E/S   lista de reservas                                          */
/*hotel      E/S   lista de habitaciones                                      */
/******************************************************************************/
void facturas(fecha hoy,ListaR & reservas,ListaH & hotel)
{
   Habitacion h,h1;
   Reserva r;
   ofstream f;
   string s, s1;
   int dias;
   
   hotel.IrAInicio();
   while(!hotel.FinalLista())
   {
      hotel.Consulta(h);
      if (h.ocupada)
      {
         reservas.IrAInicio();
         while(!reservas.FinalLista())
         {
            reservas.Consulta(r);
            if (r.NumHabitaR == h.NumHabita)
            {
               if (igual(hoy,r.salida))
               {
                  reservas.Eliminar();
                  EnteroACadena(r.NumReserva,s1);
                  s = "c:\\tmp\\factura";
                  s = s + s1;
                  s = s + ".txt";
                  f.open(s.c_str());
                  if(!f)
                     cout << "Error en apertura de fichero" << endl;
                  else
                  {
                     f << r.nombre << endl;
                     f << "Fecha de factura: ";
                     if(hoy.dia < 10)
                        f << "0";
                     f << hoy.dia << "/";
                     if(hoy.mes < 10) 
                        f << "0";
                     f << hoy.mes << "/";
                     if(hoy.anyo < 10)
                        f << "2000";
                     else
                        f << "200";
                     f << hoy.anyo << endl;
                     f << "Habitacion: " << h.NumHabita << endl;
                     f << "Reserva: " << r.NumReserva << endl;
                     f << "Entrada: ";
                     if(r.entrada.dia < 10)
                        f << "0";
                     f << r.entrada.dia << "/";
                     if(r.entrada.mes < 10) 
                        f << "0";
                     f << r.entrada.mes << "/";
                     if(r.entrada.anyo < 10)
                        f << "2000";
                     else
                        f << "200";
                     dias = numerodias (r);
                     f << endl << "Dias: " << dias << endl;
                     f << "Precio por dia: " << h.precio << endl;
                     f << "Total: " << h.precio * dias << endl;
                     f.close();
                  }
                  h.ocupada = false;
                  hotel.Eliminar();
                  if(hotel.ListaVacia())
                     hotel.Insertar(h);
                  else
                  {                     
                     hotel.IrAInicio();
                     hotel.Consulta(h1);
                     while(h1.NumHabita < h.NumHabita)
                     {
                        hotel.Avanzar();
                        hotel.Consulta(h1);
                     }   
                     hotel.Insertar(h); 
                  }      
               }
               else
                  reservas.Avanzar();
            }
            else
               reservas.Avanzar();
         }
      }
      hotel.Avanzar();
   }
}

/******************************************************************************/
/*numerodias      calcula el numero de dias de estancia en el hotel           */
/*parametros E/S                                                              */
/*r          E     reserva de la que se va a calcular el numero de dias       */
/*devuelve numero de dias de estancia                                         */
/******************************************************************************/
int numerodias (Reserva r)
{
   int dias;
   
   dias = r.salida.dia - r.entrada.dia;
   
   if (r.entrada.mes != r.salida.mes)
      dias = (r.salida.mes - r.entrada.mes)*30 + dias;
   
   if (r.entrada.anyo != r.salida.anyo)      
      dias = (r.salida.anyo - r.entrada.anyo)*360 + dias;
   
   return dias;
}

/******************************************************************************/
/*posiblecambio     comprueba si es posible hacer una cambio de la fecha de   */
/*                salida y en su caso genera los datos para nueva reserva     */                                                    
/*parametros E/S                                                              */
/*nuevasalida E     nuevas fecha de salida                                    */
/*r           S     reserva actual modificada                                 */
/*reservas    E     lista de reservas existentes                              */
/*rnuevo      S     nueva reserva si debe ponerse en nueva habitacion         */
/*devuelve si ha sido posible                                                 */
/******************************************************************************/
bool posiblecambio (fecha nuevasalida, Reserva & r, ListaR reservas, Reserva & rnuevo)
{
   bool posible = false;
   bool encontrado = false;
   Reserva r1;
   fecha maximasalida,ns;
         
   if (mayor(r.salida,nuevasalida)) //si se acorta estancia
   {
      posible = true;
      r.salida.dia = nuevasalida.dia;
      r.salida.mes = nuevasalida.mes;
      r.salida.anyo = nuevasalida.anyo;
   }
   else
   {
      //comprobar si se interfiere con la siguiente reserva
      reservas.IrAInicio();
      while(!encontrado)
      {
         reservas.Consulta(r1);
         if(r1.NumReserva == r.NumReserva) 
            encontrado = true;
         else
            reservas.Avanzar();   
      }
      if(reservas.FinalLista()) //era ultima reserva
         posible = true;
      else
      {
         reservas.Avanzar();
         reservas.Consulta(r1); //se coge la siguiente reserva
         maximasalida = r1.entrada;
         if (mayor (maximasalida,nuevasalida))
            posible = true;
         else
         {  //si hay interferencias
            ns.dia = nuevasalida.dia;
            ns.mes = nuevasalida.mes;
            ns.anyo = nuevasalida.anyo;
            nuevasalida.dia = maximasalida.dia;
            nuevasalida.mes = maximasalida.mes;
            nuevasalida.anyo = maximasalida.anyo;
         }      
      }     //datos para modificar reserva actual 
      r.salida.dia = nuevasalida.dia;
      r.salida.mes = nuevasalida.mes;
      r.salida.anyo = nuevasalida.anyo;
      if(!posible)
      {   //datos para pedir reserva nueva en extension
         rnuevo.entrada.dia = r1.entrada.dia;
         rnuevo.entrada.mes = r1.entrada.mes;
         rnuevo.entrada.anyo = r1.entrada.anyo;
         rnuevo.salida.dia = ns.dia;
         rnuevo.salida.mes = ns.mes;
         rnuevo.salida.anyo = ns.anyo;
         rnuevo.nombre = r.nombre;
      }  
   }
    
   return posible;   
}
